(*	esercizio 5.5 pagina 79 del testo
	Algoritmi e Strutture Dati (Alan Bertossi)

	La differenza simmetrica di due insiemi A e B  data
	da tutti gli elementi che stanno nell'unione dei due 
	insiemi ma non nella lorointersezione. 
	Si scrivano tre procedure Pascal per il nuovo operatore 
	DIFFERENZA-SIMMETRICA, assumendo realizzazioni con vettori 
	booleani, liste non ordinate e liste ordinate, rispettivamente.

	Soluzione con VETTORI BOOLEANI.

	Come si sarebbe potuto implementare
	DifferenzaSimmetrica() in modo da ridurre di un fattore 
	moltiplicativo il suo costo computazionale?	
*)
program esempio_insieme;
(* numero massimo di elementi *)
const N=20;
type insieme = packed array[1..N] of boolean;

var	pari	: insieme;
	unodieci : insieme;
	diffsim : insieme;

	tmp	: integer;

Procedure CreaInsieme(var A:insieme);
var i:integer;
Begin
	for i:=1 to N do A[i] := false

End;

(* qual' il costo computazionale di questa
funzione? si sarebbe potuto abbassare? *)
Function InsiemeVuoto(var A:insieme): boolean;
var i:integer;
Begin
	i := 1;
	while (i < N) and not A[i] do i := i+1;
	InsiemeVuoto := not A[i]
End;

Function Appartiene(i:integer; var A:insieme):boolean;
Begin
	Appartiene := A[i]
End;

Procedure Inserisci(i:integer; var A:insieme);
Begin
	A[i] := true
End;

Procedure Cancella(i:integer; var A:insieme);
Begin
	A[i] := false
End;

Procedure Unione(var A,B,C:insieme);
var i:integer;
Begin
	for i:=1 to N do C[i] := A[i] or B[i]
End;

Procedure Intersezione(var A,B,C:insieme);
var i:integer;
Begin
	for i:=1 to N do C[i] := A[i] and B[i]
End;

Procedure Differenza(var A,B,C:insieme);
var i:integer;
Begin
	for i:=1 to N do C[i] := A[i] and not B[i]
End;

Procedure DifferenzaSimmetrica(var A,B,C:insieme);
var	tmp1 : insieme;
	tmp2 : insieme;
Begin
	CreaInsieme(tmp1);
	Unione(A, B, tmp1);

	CreaInsieme(tmp2);
	Intersezione(A, B, tmp2);

	Differenza(tmp1, tmp2, C)
End;

Procedure Visita(A:insieme);
var i:integer;
Begin
	for i:=1 to N do	if A[i] then write(i, ' ');
	writeln()
End;

Begin
	CreaInsieme(pari);

	for tmp:= 2 to N do
		if (tmp mod 2) = 0 then	Inserisci(tmp, pari);

	Visita(pari);		

	CreaInsieme(unodieci);

	for tmp:= 1 to 10 do	Inserisci(tmp, unodieci);

	Visita(unodieci);		

	CreaInsieme(diffsim);
	DifferenzaSimmetrica(pari, unodieci, diffsim);

	Visita(diffsim)
End.